\usepackage{xcolor}

\providecommand{\colorprovide}[2]{\@ifundefined{\string\color@#1}{\colorlet{#1}{#2}}{}}

\colorprovide{keyword}{blue}
\colorprovide{string}{purple}
\colorprovide{comment}{green}
\colorprovide{identifier}{black}

\usepackage{listings}
\lstdefinestyle{basestyle}{
	numbers=left,
	stepnumber=1,
	numbersep=6pt,
	numberstyle=\scriptsize\textbf,
	breaklines=true,
	breakautoindent=true,
	breakatwhitespace=false,
	numberblanklines=false,
	postbreak=\space,
	tabsize=4,
	basicstyle=\ttfamily\small,
	showspaces=false,
	showstringspaces=true,
	extendedchars=true,
	keywordstyle=\color{keyword}\bfseries,
	stringstyle=\color{string}\bfseries,
	commentstyle=\color{comment}\bfseries\itshape,
	identifierstyle=\color{identifier},
	frame=none,
	aboveskip=0pt,
	belowskip=0pt,
	xleftmargin=3.1ex,
	framexleftmargin=3.1ex,
	escapechar=@
}

% Listings doesn't support UTF8. This is just enough for German umlauts.
\lstset{literate=%
  {Ö}{{\"O}}1
  {Ä}{{\"A}}1
  {Ü}{{\"U}}1
  {ß}{{\ss}}1
  {ü}{{\"u}}1
  {ä}{{\"a}}1
  {ö}{{\"o}}1
  {~}{{\textasciitilde}}1
}

\makeatletter 
\lst@AddToHook{OnEmptyLine}{\vspace{\dimexpr-\baselineskip+0.5em}\addtocounter{lstnumber}{-1}} 
\makeatother 